module elements

    use precision_comm_module

    implicit none

    !This is the data structure which is used to represent the CAC elements
    type element
        integer :: tag = 0 !Element tag (used to keep track of id's
        integer :: type = 0 !Lattice type of the element
        integer :: size = 0 !Element size
        !Nodal position array below only works for wedge or fcc elements
        real(kind=wp) :: r_node(3,8)    
    end type

    !Finite element array
    type(element), allocatable :: element_array(:)

    integer :: ele_num

    !Data structure used to represent atoms
    type atom
        integer :: tag = 0
        integer :: type = 0
        real(kind =wp) :: r
    end type

    type(atom), allocatable :: atoms(:)

    integer :: atom_num

end module elements